<template>
  <div class="register">
    <h1>Register</h1>
    <p>
      SSO is yet to be implemented. For now, you can register and
      <router-link to="/login">log in</router-link> with your email address and
      password.
    </p>

    <p v-show="error" style="color: red">
      Something went wrong, please double-check your input or try it later
      again. Error message: {{ error }}
    </p>

    <b-form @submit="register">
      <b-row>
        <b-col md="6">
          <b-form-input
            v-model="registerName"
            :state="registerName.length > 1"
            placeholder="Enter your Name"
            trim
          />
        </b-col>
        <b-col md="6">
          <b-form-input
            v-model="registerEmail"
            :state="validRegisterEmailFormat"
            placeholder="Enter your E-Mail address"
            trim
          />
        </b-col>
      </b-row>
      <b-row>
        <b-col>
          <b-form-input
            type="password"
            v-model="registerPassword"
            :state="validRegisterPasswordFormat"
            placeholder="Enter your Password"
            trim
          />
          <b-form-invalid-feedback>
            Enter at least 10 characters.
          </b-form-invalid-feedback>
        </b-col>
      </b-row>
      <b-row v-show="false">
        <b-col>
          <b-form-input
            type="password"
            v-model="honeypot"
            :state="validRegisterPasswordFormat"
            placeholder="Confirm your Password"
            trim
          />
        </b-col>
      </b-row>
      <b-button
        type="submit"
        variant="primary"
        :active="
          registerName &&
            validRegisterEmailFormat &&
            validRegisterPasswordFormat
        "
        :disabled="
          !registerName ||
            !validRegisterPasswordFormat ||
            !validRegisterPasswordFormat
        "
      >
        Register
      </b-button>
    </b-form>
  </div>
</template>

<script>
import gql from "graphql-tag";

export default {
  computed: {
    validRegisterPasswordFormat() {
      return this.registerPassword.length >= 10;
    },
    validRegisterEmailFormat() {
      return /\S+@\S+\.\S+/.test(this.registerEmail);
    }
  },
  data() {
    return {
      error: null,
      registerName: "",
      registerPassword: "",
      registerEmail: "",
      honeypot: ""
    };
  },
  methods: {
    getToken() {
      return localStorage.getItem("OC_AUTH_TOKEN") || null;
    },
    register(evt) {
      evt.preventDefault();
      if (this.honeypot) window.location.href = "/";
      this.$apollo
        .mutate({
          mutation: gql`
            mutation($email: String!, $password: String!, $name: String!) {
              register(email: $email, password: $password, name: $name) {
                id
              }
            }
          `,
          variables: {
            email: this.registerEmail,
            password: this.registerPassword,
            name: this.registerName
          }
        })
        .then(() => {
          // Do not use router to force re-rendering the login and account nav elements
          window.location.href = "/confirm";
        })
        .catch(error => {
          this.error = error;
        });
    }
  },
  created() {
    if (this.getToken()) {
      // Do not use router to force re-rendering the login and account nav elements
      window.location.href = "/account";
    }
  }
};
</script>
